#define FILTER


defval jtlag 3//nombre de pas de temps Delta t/ delta t 
//for the fake
//defval jtlag 720

defval jptfl 7 //Nombre total de pas de temps
defval jpnfl 2 //nombre total de flotteurs


defval nlon 87 //nbre de points de grilles en longitude
defval nlat 58 //nbre de points de grilles en latitude
defval nfloat 2  //nbre de flotteurs max par assim

#ifdef FILTER
defval K_FILTER //create a define K_FILTER in the source code
defval OFIL 2  //order of the filter
#else
defval OFIL 0 //Offtime of the main trajectory (0 since there is no filter)
#endif


hat_name "floater.h"


option o_m1qn3
option o_gradtest
//option  O_EXTOBJ "../object/ncutil.o" //for aviso files
#ifdef FILTER
traj Tcstfil D 0    1 //Traj for control parameters
traj Tfil    D 1    0     1    OFIL  //Traj for compute the filter
#endif

//    name   M upt offt  dt    nbstep
traj T_float M 1    OFIL  1    jtlag //trajectoire pour r 
traj T_euler M 0    OFIL  1    jtlag //trajectoire pour u et v
//for varibale u, put under nb step jtlag 

//deltas
traj T_euler_d  D 0    OFIL     1    1 
traj T_float_d D 1    OFIL     1    jtlag //trajectoires type modele ou tangent. permet de controler quel type activer dans le i


#ifdef FILTER
space S_euler_df   M nlon nlat Tcstfil //space for control parameter
space S_euler_df_t M nlon nlat Tfil //space for filter calculation
#endif

space S_float M nfloat    T_float
space S_euler M nlon nlat T_euler
space S_eulerlocate M nfloat nlon nlat T_float

//deltas
space S_float_d M nfloat    T_float_d
space S_euler_d M nlon nlat T_euler_d
space S_eulerlocate_d M nfloat nlon nlat T_float_d


modul r_float space S_float input 4  output 2 tempo 
modul ur      space S_float input 18 output 2 tempo
modul uinter space S_float noward   output 8 tempo
modul xinter space S_float noward   output 8 tempo


modul u       space S_euler noward   output 1  tempo //noward veut dire pas de calcul
modul v		  space S_euler noward   output 1 tempo
modul locate  space S_eulerlocate input 2  output 1 tempo
modul mask    space S_euler noward output 1


//deltas
modul r_float_d space S_float_d input 4  output 2 tempo 
modul ur_d      space S_float_d input 18 output 2 tempo
modul uinter_d space S_float_d noward   output 8 tempo
//modul xinter_d space S_float_d noward   output 8 tempo



#ifdef FILTER
//active filter
modul uc_d     space S_euler_df noward output 1 target
modul vc_d     space S_euler_df noward output 1 target
modul cfil	   space S_euler_df noward output 9
modul dfil     space S_euler_df noward output 9
modul lapfilu  space S_euler_df_t input 20 output 1 tempo
modul lapfilv space  S_euler_df_t clonol lapfilu
modul u_d      space S_euler_d  input 2 output 1
modul v_d      space S_euler_d  clonol u_d
modul u_norm   space S_euler_df noward output 1 
modul v_norm   space S_euler_df noward output 1

#else
//no filter
modul u_d       space S_euler_d noward   output 1 target //noward veut dire pas de calcul
modul v_d		  space S_euler_d noward   output 1 target
#endif

modul locate_d  space S_eulerlocate_d input 2  output 1 tempo
modul r_cout_d space S_float_d input 2  output 2 tempo cout

//Filter modules




exec disp_modul //afficher les modules lors de la ganeration du code

ctin r_float  1..2   from r_float 1..2 i t-1 // i par default est la premier dimension, ici i=1 floater
ctin r_float  3..4   from ur      1..2 i t    // comme c'est un calcul, il depend pas de la valeur initiale

ctin ur       1..8   from uinter 1..8 i t
ctin ur       9..16  from xinter 1..8 i t
ctin ur       17..18 from r_float 1..2 i t-1

ctin locate   1..2   from r_float 1..2 i t-1
 
//deltas
ctin r_float_d  1..2   from r_float_d 1..2 i t-1 // i par default est la premier dimension, ici i=1 floater
ctin r_float_d  3..4   from ur_d       1..2 i t    // comme c'est un calcul, il depend pas de la valeur initiale

ctin ur_d       1..8   from uinter_d 1..8 i t
ctin ur_d       9..16  from xinter 1..8 i t
ctin ur_d       17..18 from r_float 1..2 i t-1

ctin locate_d   1..2   from r_float_d 1..2 i t-1
ctin r_cout_d   1..2   from r_float_d 1..2 i t       

#ifdef FILTER
ctin lapfilu    1      from  uc_d     1  i    j
ctin lapfilu    2      from  lapfilu  1  i    j   t-1
ctin lapfilu    3      from  lapfilu  1  i+1  j   t-1
ctin lapfilu    4      from  lapfilu  1  i    j+1      t-1
ctin lapfilu    5      from  lapfilu  1  i    j-1    t-1
ctin lapfilu    6      from  lapfilu  1  i-1  j    t-1
ctin lapfilu    7      from  lapfilv  1  i    j      t-1
ctin lapfilu    8      from  lapfilv  1  i+1  j-1   t-1
ctin lapfilu    9      from  lapfilv  1  i    j-1   t-1
ctin lapfilu    10      from  lapfilv 1  i+1  j     t-1
ctin lapfilu    11..19 from  cfil     1..9 i j
ctin lapfilu    20     from  mask     1  i  j

ctin lapfilv    1      from  vc_d     1  i   j
ctin lapfilv    2      from  lapfilv  1  i   j   t-1
ctin lapfilv    3      from  lapfilv  1  i+1 j   t-1
ctin lapfilv    4      from  lapfilv  1  i   j+1      t-1
ctin lapfilv    5      from  lapfilv  1  i   j-1    t-1
ctin lapfilv    6      from  lapfilv  1  i-1 j    t-1
ctin lapfilv    7      from  lapfilu  1  i   j      t-1
ctin lapfilv    8      from  lapfilu  1  i   j+1   t-1
ctin lapfilv    9      from  lapfilu  1  i-1 j   t-1
ctin lapfilv    10      from  lapfilu 1  i-1 j+1     t-1
ctin lapfilv    11..19 from  dfil     1..9 i j
ctin lapfilv    20     from  mask     1  i  j

ctin u_d       1      from  lapfilu   1  i   j   t
ctin u_d       2      from  u_norm    1  i   j

ctin v_d       1      from  lapfilv   1  i   j   t
ctin v_d       2      from  v_norm    1  i   j

#endif


exec disp_ct_in //afficher les connexions

#ifdef FILTER
order modinspace S_euler_df_t
        order YA1 YA2
               lapfilu lapfilv
        forder
forder

order modinspace S_euler_d
        order YA1 YA2
            u_d v_d
        forder
forder
#endif

order modinspace S_float
	order YA1
		ur r_float
	forder
forder

order modinspace S_eulerlocate
	order YA1 YA2 YA3
		locate
	forder
forder

order spaceintraj T_float
	S_eulerlocate S_float
forder
 
//deltas
order modinspace S_float_d
	order YA1
		ur_d r_float_d r_cout_d
	forder
forder

order modinspace S_eulerlocate_d
	order YA1 YA2 YA3
		locate_d
	forder
forder

#ifdef FILTER
order spaceintraj Tfil
        S_euler_df_t
forder

order spaceintraj T_euler_d
        S_euler_d
forder
#endif

order spaceintraj T_float_d
	S_eulerlocate_d S_float_d
forder
 
 
//insert_fct arg load_aviso
insert_fct update_uv
insert_fct arg run_inc
insert_fct arg read_obs
insert_fct multirun
insert_fct arg save_output_uv
